--liquibase formatted sql
--changeset stv:1063 endDelimiter:^ rollbackEndDelimiter:^

-- Устанавливаем путь к схеме
SET search_path TO dbo,public^

/* Права на электронный материал документа */
CREATE TABLE documentappendixrole (
	documentappendixrole_id	INTEGER NOT NULL,
	accessrole_id	INTEGER NOT NULL,
	appendixtype_id 	INTEGER NOT NULL,
	document_id	INTEGER NOT NULL,
	sqlaction_id	INTEGER NOT NULL,
	CONSTRAINT documentappendixrole_pk PRIMARY KEY (documentappendixrole_id),
	CONSTRAINT documentappendixrole_ak1 UNIQUE (accessrole_id, appendixtype_id , document_id, sqlaction_id)
)^
ALTER TABLE documentappendixrole ADD
	CONSTRAINT documentappendixrole_fk1 FOREIGN KEY (accessrole_id) REFERENCES accessrole ON DELETE CASCADE^
ALTER TABLE documentappendixrole ADD
	CONSTRAINT documentappendixrole_fk2 FOREIGN KEY (appendixtype_id ) REFERENCES capclass ON DELETE CASCADE^
ALTER TABLE documentappendixrole ADD
	CONSTRAINT documentappendixrole_fk3 FOREIGN KEY (document_id) REFERENCES document ON DELETE CASCADE^
ALTER TABLE documentappendixrole ADD
	CONSTRAINT documentappendixrole_fk4 FOREIGN KEY (sqlaction_id) REFERENCES sqlaction ON DELETE CASCADE^
CREATE INDEX documentappendixrole_if1 ON documentappendixrole (accessrole_id)^
CREATE INDEX documentappendixrole_if2 ON documentappendixrole (appendixtype_id )^
CREATE INDEX documentappendixrole_if3 ON documentappendixrole (document_id)^
CREATE INDEX documentappendixrole_if4 ON documentappendixrole (sqlaction_id)^
COMMENT ON TABLE documentappendixrole IS 'Права на электронный материал документа'^
COMMENT ON COLUMN documentappendixrole.documentappendixrole_id IS 'Права на электронный материал документа ИД'^
COMMENT ON COLUMN documentappendixrole.accessrole_id IS 'Роль ИД'^
COMMENT ON COLUMN documentappendixrole.appendixtype_id  IS 'Тип электронного материала ИД'^
COMMENT ON COLUMN documentappendixrole.document_id IS 'Тип документа ИД'^
COMMENT ON COLUMN documentappendixrole.sqlaction_id IS 'Действие ИД'^

CREATE SEQUENCE documentappendixrole_id_gen AS INTEGER START WITH 1 INCREMENT BY 1^
ALTER SEQUENCE documentappendixrole_id_gen OWNED BY documentappendixrole.documentappendixrole_id^

--rollback ALTER TABLE documentappendixrole DROP CONSTRAINT documentappendixrole_fk1^
--rollback ALTER TABLE documentappendixrole DROP CONSTRAINT documentappendixrole_fk2^
--rollback ALTER TABLE documentappendixrole DROP CONSTRAINT documentappendixrole_fk3^
--rollback ALTER TABLE documentappendixrole DROP CONSTRAINT documentappendixrole_fk4^
--rollback ALTER TABLE reasondowntime DROP CONSTRAINT reasondowntime_fk2^
--rollback DROP SEQUENCE documentappendixrole_id_gen^
--rollback DROP TABLE documentappendixrole^
