--liquibase formatted sql
--changeset stv:1091 endDelimiter:^ rollbackEndDelimiter:^


-- Устанавливаем путь к схеме
SET search_path TO dbo,public^

/* Лог отправки сообщений в интеграционную шину */
CREATE TABLE senderlog (
	senderlog_id	INTEGER NOT NULL,
	senderlog_datetime	DATE NOT NULL,
	entity_id	INTEGER NOT NULL,
	senderlog_message_id	VARCHAR(100),
	senderlog_status	INTEGER,
	senderlog_error_message	VARCHAR(1024),
	senderlog_type_id	INTEGER NOT NULL,
	CONSTRAINT senderlog_pk PRIMARY KEY (senderlog_id)
)^
ALTER TABLE senderlog ADD
	CONSTRAINT senderlog_fk1 FOREIGN KEY (senderlog_type_id) REFERENCES capcode^
CREATE INDEX senderlog_if1 ON senderlog (senderlog_type_id)^
CALL CREATE_EXCEPTION('senderlog_id_null', 'IIIНе указано значение поля "Лог отправки сообщений в интеграционную шину".III')^
CALL CREATE_EXCEPTION('senderlog_unique', 'IIIЛог отправки сообщений в интеграционную шину уже существует.III')^
CALL CREATE_EXCEPTION('senderlog_notfk', 'IIIНет значения поля для Лог отправки сообщений в интеграционную шину.III')^
CALL CREATE_EXCEPTION('senderlog_datetime_null', 'IIIНе указано значение поля "Дата".III')^
CALL CREATE_EXCEPTION('entity_id_null', 'IIIНе указано значение поля "Запись ИД".III')^
CREATE SEQUENCE senderlog_id_gen AS INTEGER START WITH 1 INCREMENT BY 1^
ALTER SEQUENCE senderlog_id_gen OWNED BY senderlog.senderlog_id^
INSERT INTO captable (captable_code, captable_name, captable_temp, captable_schema) 
VALUES (Upper('senderlog'), 'Лог отправки сообщений в интеграционную шину', 0, (SELECT CAST(configsystem_value AS VARCHAR(30)) FROM configsystem WHERE configsystem_id=2))^

--Коментарии к столбцам
COMMENT ON COLUMN senderlog.senderlog_id IS 'Лог отправки сообщений в интеграционную шину ИД'^
COMMENT ON COLUMN senderlog.senderlog_datetime IS 'Дата'^
COMMENT ON COLUMN senderlog.entity_id IS 'Запись ИД'^
COMMENT ON COLUMN senderlog.senderlog_message_id IS 'Сообщение в шине ИД'^
COMMENT ON COLUMN senderlog.senderlog_status IS 'Статус'^
COMMENT ON COLUMN senderlog.senderlog_error_message IS 'Сообщение об ошибке'^
COMMENT ON COLUMN senderlog.senderlog_type_id IS 'Тип сообщения'^

--rollback DELETE FROM captable WHERE captable_code = Upper('senderlog') AND captable_name = 'Лог отправки сообщений в интеграционную шин'^
--rollback ALTER TABLE senderlog DROP CONSTRAINT senderlog_fk1^
--rollback DROP SEQUENCE senderlog_id_gen^
--rollback DROP TABLE senderlog^
