CREATE TABLE worker(
	worker_id INTEGER NOT NULL,
	worker_tabnumber VARCHAR(15) NOT NULL,
	worker_familyname VARCHAR(30) NOT NULL,
	worker_firstname VARCHAR(30) NOT NULL,
	worker_surname VARCHAR(30),
	worker_sex INTEGER NOT NULL,
	worker_birthday DATE,
	worker_email VARCHAR(50),
	worker_homephone VARCHAR(50),
	worker_workphone VARCHAR(50),
	worker_contactphone VARCHAR(50),
	worker_remark VARCHAR(255),
    CONSTRAINT worker_pk PRIMARY KEY (worker_id)
);
CREATE SEQUENCE worker_id_gen AS INTEGER START WITH 1 INCREMENT BY 1;
ALTER SEQUENCE worker_id_gen OWNED BY worker.worker_id;

CREATE VIEW ft_worker
AS
SELECT
	worker_id,
	CAST(
		trim(worker_tabnumber)||' '||trim(worker_familyname)||' '||trim(worker_firstname)||' '||coalesce(worker_surname,'')||' '||coalesce(to_char(worker_birthday, 'DD.MM.YYYY'),'')||' '||coalesce(worker_email,'')||' '||coalesce(worker_homephone,'')||' '||coalesce(worker_workphone,'')||' '||coalesce(worker_contactphone,'')||' '||coalesce(worker_remark,'')
		AS varchar(593)
	) AS fulltext
FROM worker;

